Skip to navigation

Reconcile a refund

View as Markdown
Reconciles a refund when receiving the gateway reconciliation request or event.

Authentication

AuthorizationBearer

Use Bearer {{token}} in the Authorization header for authentication.

Path parameters

refund-keystringRequired

The refund number starting with “R-” or the unique refund ID.

Headers

Idempotency-KeystringOptional<=255 characters
Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident.
Accept-EncodingstringOptional

Include the Accept-Encoding: gzip header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response.

If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a Content-Encoding header with the compression algorithm so that your client can decompress it.

Content-EncodingstringOptional

Include the Content-Encoding: gzip header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.

Zuora-Track-IdstringOptional<=64 characters

A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue.

The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (:), semicolon (;), double quote ("), and quote (').

Zuora-Entity-IdsstringOptional

An entity ID. If you have Zuora Multi-entity enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.

Zuora-Org-IdsstringOptional

Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header.

The IDs must be a sub-set of the user’s accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user’s accessible orgs.

Zuora-VersionstringOptional

The minor API version.

For a list of available minor versions, see API upgrades.

Request

This endpoint expects an object.
actionenumOptional

The action of the refund reconciliation.

  • settle: Sets Gateway State to “Settled” and returns the refund object as response.
  • reject: Sets Gateway State to “FailedToSettle” and handle the event according to the settings configured in the Gateway Reconciliation Configuration in Payments Settings through Zuora UI. See Configure how to handle refund rejected events for details.
Allowed values:
actionDatestringOptionalformat: "datetime"

The date and time of the refund reconciliation action, in yyyy-mm-dd hh:mm:ss format.

gatewayReconciliationReasonstringOptional
The reason of gateway reconciliation.
gatewayReconciliationStatusstringOptional
The status of gateway reconciliation.
payoutIdstringOptional
The payout ID of the refund from the gateway side.

Response headers

Content-EncodingstringOptional

This header is returned if you specify the Accept-Encoding: gzip request header and the response contains over 1000 bytes of data.

Note that only the following MIME types support gzipped responses:

  • application/json
  • application/xml
  • text/html
  • text/csv
  • text/plain
RateLimit-LimitstringOptional

The request limit quota for the time window closest to exhaustion. See rate limits for more information.

RateLimit-Remainingdouble

The number of requests remaining in the time window closest to quota exhaustion. See rate limits for more information.

RateLimit-Resetdouble

The number of seconds until the quota resets for the time window closest to quota exhaustion. See rate limits for more information.

Zuora-Request-IdstringOptional
The Zuora internal identifier of the API call. You cannot control the value of this header.
Zuora-Track-IdstringOptional
A custom identifier for tracing the API call. If you specified a tracing identifier in the request headers, Zuora returns the same tracing identifier. Otherwise, Zuora does not set this header.
Concurrency-Limit-TypestringOptional

The type of the concurrency limit, which can be Default, High-volume transactions, or Object Query.

For more information, see Concurrent request limits.

Concurrency-Limit-Limitinteger

The total number of the permitted concurrent requests.

For more information, see Concurrent request limits.

Concurrency-Limit-Remaininginteger

The remaining number of the permitted concurrent requests.

For more information, see Concurrent request limits.

Response

OK
accountIdstringOptional
The ID of the customer account that the refund is for.
amountdoubleOptional
The total amount of the refund.
cancelledOnstringOptional

The date and time when the transaction was cancelled, in yyyy-mm-dd hh:mm:ss format.

commentstringOptional
Comments about the refund.
createdByIdstringOptional
The ID of the Zuora user who created the refund.
createdDatestringOptional

The date and time when the refund is created, in yyyy-mm-dd hh:mm:ss format.

creditMemoIdstringOptional
The ID of the credit memo that is refunded.
financeInformationobjectOptional
Container for the finance information related to the refund.
gatewayIdstringOptional
The ID of the gateway instance that processes the refund.
gatewayReconciliationReasonstringOptional
The reason of gateway reconciliation.
gatewayReconciliationStatusstringOptional
The status of gateway reconciliation.
gatewayResponsestringOptional

The message returned from the payment gateway for the refund. This message is gateway-dependent.

gatewayResponseCodestringOptional

The code returned from the payment gateway for the refund. This code is gateway-dependent.

gatewayStateenumOptional

The status of the refund in the gateway; specifically used for reconciliation.

Allowed values:
idstringOptional
The ID of the refund.
markedForSubmissionOnstringOptional

The date and time when a refund was marked and waiting for batch submission to the payment process, in yyyy-mm-dd hh:mm:ss format.

methodTypeenumOptional
How an external refund was issued to a customer.
numberstringOptional

The unique identification number of the refund. For example, R-00000001.

organizationLabelstringOptional

The organization that this object belongs to.

Note: This field is available only when the Multi-Org feature is enabled.

paymentIdstringOptional
The ID of the payment that is refunded.
paymentMethodIdstringOptional
The unique ID of the payment method that the customer used to make the refund.
paymentMethodSnapshotIdstringOptional
The unique ID of the payment method snapshot which is a copy of the particular Payment Method used in a transaction.
payoutIdstringOptional
The payout ID of the refund from the gateway side.
reasonCodestringOptional
A code identifying the reason for the transaction.
referenceIdstringOptional
The transaction ID returned by the payment gateway for an electronic refund. Use this field to reconcile refunds between your gateway and Zuora Payments.
refundDatedateOptional

The date when the refund takes effect, in yyyy-mm-dd format. For example, 2020-03-01.

refundTransactionTimestringOptional

The date and time when the refund was issued, in yyyy-mm-dd hh:mm:ss format.

secondRefundReferenceIdstringOptional
The transaction ID returned by the payment gateway if there is an additional refund.
settledOnstringOptional

The date and time when the transaction is settled, in yyyy-mm-dd hh:mm:ss format.

softDescriptorstringOptional

A payment gateway-specific field that maps Zuora to other gateways.

softDescriptorPhonestringOptional

A payment gateway-specific field that maps Zuora to other gateways.

statusstringOptional
The status of the refund.
submittedOnstringOptional

The date and time when the refund was submitted, in yyyy-mm-dd hh:mm:ss format.

successbooleanOptional
Indicates if the request is processed successfully.
typeenumOptional
The type of the refund.
Allowed values:
updatedByIdstringOptional
The ID of the Zuora user who last updated the refund.
updatedDatestringOptional

The date and time when the refund was last updated, in yyyy-mm-dd hh:mm:ss format.

Errors

4XX
Client Request Error
500
Internal Server Error